package com.ruoyi.web.base.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.BaseSubAccount;
import com.ruoyi.web.base.service.IBaseSubAccountService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

/**
 * <p>
 * 二级科目 前端控制器
 * </p>
 *
 * @author author
 * @since 2026-02-04
 */
@RestController
@RequestMapping("/base-sub-account")
public class BaseSubAccountController {
    @Autowired
    private IBaseSubAccountService baseSubAccountService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("二级科目管理添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody BaseSubAccount baseSubAccount, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseSubAccountService.count(new QueryWrapper<BaseSubAccount>().eq("org_id",loginOrgId).eq("sub_num", baseSubAccount.getSubNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseSubAccount.setOrgId(loginOrgId);
        baseSubAccount.setCreateBy(getUsername());

        return success(baseSubAccountService.save(baseSubAccount));
    }

    @ApiOperation("二级科目管理修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody BaseSubAccount baseSubAccount, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseSubAccountService.count(new QueryWrapper<BaseSubAccount>().ne("id",baseSubAccount.getId()).eq("org_id",loginOrgId).eq("sub_num", baseSubAccount.getSubNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseSubAccount.setUpdateBy(getUsername());
        return success(baseSubAccountService.updateById(baseSubAccount));
    }

    @ApiOperation("二级科目管理删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String s : ids.split(",")) {
            baseSubAccountService.removeById(s);
        }
        return success();
    }

    @ApiOperation("二级科目管理列表")
    @PostMapping("/list")
    public AjaxResult listAll( HttpServletRequest request){

        return success(baseSubAccountService.list(new QueryWrapper<BaseSubAccount>().eq("org_id", tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("二级科目管理分页")
    @GetMapping("/page")
    public AjaxResult page(@RequestParam("pageNum") Integer pageNum, @RequestParam("pageSize") Integer pageSize
            , HttpServletRequest request) {
        return success(baseSubAccountService.page(new Page<BaseSubAccount>(pageNum,pageSize),new QueryWrapper<BaseSubAccount>().eq("org_id", tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("二级科目管理详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return success(baseSubAccountService.getById(id));
    }


}
